Index: trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/MultiBinaryVectorCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/MultiBinaryVectorCrossover.cs	(revision 3425)
+++ trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/MultiBinaryVectorCrossover.cs	(revision 3425)
@@ -0,0 +1,89 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.BinaryVectorEncoding {
+  [Item("MultiBinaryVectorCrossover", "Randomly selects and applies one of its crossovers every time it is called.")]
+  [StorableClass]
+  public class MultiBinaryVectorCrossover : StochasticMultiOperator<IBinaryVectorCrossover>, IBinaryVectorCrossover {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    protected override bool CreateChildOperation {
+      get { return true; }
+    }
+    public override bool AutomaticTypeDiscovery {
+      get { return true; }
+    }
+
+    public ILookupParameter<ItemArray<BinaryVector>> ParentsParameter {
+      get { return (ILookupParameter<ItemArray<BinaryVector>>)Parameters["Parents"]; }
+    }
+
+    public ILookupParameter<BinaryVector> ChildParameter {
+      get { return (ILookupParameter<BinaryVector>)Parameters["Child"]; }
+    }
+
+    [StorableConstructor]
+    private MultiBinaryVectorCrossover(bool deserializing) : base(deserializing) { }
+    public MultiBinaryVectorCrossover()
+      : base() {
+      Parameters.Add(new SubScopesLookupParameter<BinaryVector>("Parents", "The parent binary vector which should be crossed."));
+      ParentsParameter.ActualName = "BinaryVector";
+      Parameters.Add(new LookupParameter<BinaryVector>("Child", "The child binary vector resulting from the crossover."));
+      ChildParameter.ActualName = "BinaryVector";
+
+      Initialize();
+      ParameterizeCrossovers();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      Operators.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IBinaryVectorCrossover>>(Operators_ItemsAdded);
+      Operators.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<IBinaryVectorCrossover>>(Operators_ItemsReplaced);
+    }
+
+    private void Operators_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IBinaryVectorCrossover>> e) {
+      ParameterizeCrossovers();
+    }
+
+    private void Operators_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IBinaryVectorCrossover>> e) {
+      ParameterizeCrossovers();
+    }
+
+    private void ParameterizeCrossovers() {
+      foreach (IBinaryVectorCrossover crossover in Operators.OfType<IBinaryVectorCrossover>()) {
+        crossover.ChildParameter.ActualName = ChildParameter.Name;
+        crossover.ParentsParameter.ActualName = ParentsParameter.Name;
+      }
+      foreach (IStochasticOperator crossover in Operators.OfType<IStochasticOperator>()) {
+        crossover.RandomParameter.ActualName = RandomParameter.Name;
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj	(revision 3424)
+++ trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj	(revision 3425)
@@ -86,4 +86,5 @@
   <ItemGroup>
     <Compile Include="Creators\RandomBinaryVectorCreator.cs" />
+    <Compile Include="Crossovers\MultiBinaryVectorCrossover.cs" />
     <Compile Include="Crossovers\UniformCrossover.cs" />
     <Compile Include="Crossovers\SinglePointCrossover.cs" />
Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Crossovers/MultiIntegerVectorCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Crossovers/MultiIntegerVectorCrossover.cs	(revision 3425)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Crossovers/MultiIntegerVectorCrossover.cs	(revision 3425)
@@ -0,0 +1,89 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.IntegerVectorEncoding {
+  [Item("MultiIntegerVectorCrossover", "Randomly selects and applies one of its crossovers every time it is called.")]
+  [StorableClass]
+  public class MultiIntegerVectorCrossover : StochasticMultiOperator<IIntegerVectorCrossover>, IIntegerVectorCrossover {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    protected override bool CreateChildOperation {
+      get { return true; }
+    }
+    public override bool AutomaticTypeDiscovery {
+      get { return true; }
+    }
+
+    public ILookupParameter<ItemArray<IntegerVector>> ParentsParameter {
+      get { return (ILookupParameter<ItemArray<IntegerVector>>)Parameters["Parents"]; }
+    }
+
+    public ILookupParameter<IntegerVector> ChildParameter {
+      get { return (ILookupParameter<IntegerVector>)Parameters["Child"]; }
+    }
+
+    [StorableConstructor]
+    private MultiIntegerVectorCrossover(bool deserializing) : base(deserializing) { }
+    public MultiIntegerVectorCrossover()
+      : base() {
+      Parameters.Add(new SubScopesLookupParameter<IntegerVector>("Parents", "The parent integer vector which should be crossed."));
+      ParentsParameter.ActualName = "IntegerVector";
+      Parameters.Add(new LookupParameter<IntegerVector>("Child", "The child integer vector resulting from the crossover."));
+      ChildParameter.ActualName = "IntegerVector";
+
+      Initialize();
+      ParameterizeCrossovers();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      Operators.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IIntegerVectorCrossover>>(Operators_ItemsAdded);
+      Operators.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<IIntegerVectorCrossover>>(Operators_ItemsReplaced);
+    }
+
+    private void Operators_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IIntegerVectorCrossover>> e) {
+      ParameterizeCrossovers();
+    }
+
+    private void Operators_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IIntegerVectorCrossover>> e) {
+      ParameterizeCrossovers();
+    }
+
+    private void ParameterizeCrossovers() {
+      foreach (IIntegerVectorCrossover crossover in Operators.OfType<IIntegerVectorCrossover>()) {
+        crossover.ChildParameter.ActualName = ChildParameter.Name;
+        crossover.ParentsParameter.ActualName = ParentsParameter.Name;
+      }
+      foreach (IStochasticOperator crossover in Operators.OfType<IStochasticOperator>()) {
+        crossover.RandomParameter.ActualName = RandomParameter.Name;
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj	(revision 3424)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj	(revision 3425)
@@ -83,4 +83,5 @@
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="Crossovers\MultiIntegerVectorCrossover.cs" />
     <Compile Include="Crossovers\SinglePointCrossover.cs">
       <SubType>Code</SubType>
Index: trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Crossovers/MultiPermutationCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Crossovers/MultiPermutationCrossover.cs	(revision 3424)
+++ trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Crossovers/MultiPermutationCrossover.cs	(revision 3425)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Linq;
 using HeuristicLab.Collections;
 using HeuristicLab.Core;
@@ -27,11 +28,18 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.PermutationEncoding.Crossovers {
+namespace HeuristicLab.Encodings.PermutationEncoding {
   [Item("MultiPermutationCrossover", "Randomly selects and applies one of its crossovers every time it is called.")]
   [StorableClass]
-  public class MultiPermutationCrossover : MultiCrossover<IPermutationCrossover>, IPermutationCrossover {
+  public class MultiPermutationCrossover : StochasticMultiOperator<IPermutationCrossover>, IPermutationCrossover {
     public override bool CanChangeName {
       get { return false; }
     }
+    protected override bool CreateChildOperation {
+      get { return true; }
+    }
+    public override bool AutomaticTypeDiscovery {
+      get { return true; }
+    }
+
     public ILookupParameter<ItemArray<Permutation>> ParentsParameter {
       get { return (ILookupParameter<ItemArray<Permutation>>)Parameters["Parents"]; }
@@ -58,4 +66,9 @@
     private void Initialize() {
       Operators.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IPermutationCrossover>>(Operators_ItemsAdded);
+      Operators.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<IPermutationCrossover>>(Operators_ItemsReplaced);
+    }
+
+    private void Operators_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IPermutationCrossover>> e) {
+      ParameterizeCrossovers();
     }
 
@@ -65,9 +78,9 @@
 
     private void ParameterizeCrossovers() {
-      foreach (IPermutationCrossover crossover in Operators) {
+      foreach (IPermutationCrossover crossover in Operators.OfType<IPermutationCrossover>()) {
         crossover.ChildParameter.ActualName = ChildParameter.Name;
         crossover.ParentsParameter.ActualName = ParentsParameter.Name;
       }
-      foreach (IStochasticOperator crossover in Operators) {
+      foreach (IStochasticOperator crossover in Operators.OfType<IStochasticOperator>()) {
         crossover.RandomParameter.ActualName = RandomParameter.Name;
       }
Index: trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/HeuristicLab.Encodings.PermutationEncoding-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/HeuristicLab.Encodings.PermutationEncoding-3.3.csproj	(revision 3424)
+++ trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/HeuristicLab.Encodings.PermutationEncoding-3.3.csproj	(revision 3425)
@@ -103,4 +103,5 @@
     <Compile Include="Manipulators\InsertionManipulator.cs" />
     <Compile Include="Manipulators\InversionManipulator.cs" />
+    <Compile Include="Manipulators\MultiPermutationManipulator.cs" />
     <Compile Include="Manipulators\ScrambleManipulator.cs" />
     <Compile Include="Manipulators\Swap2Manipulator.cs" />
Index: trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Manipulators/MultiPermutationManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Manipulators/MultiPermutationManipulator.cs	(revision 3425)
+++ trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Manipulators/MultiPermutationManipulator.cs	(revision 3425)
@@ -0,0 +1,81 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.PermutationEncoding {
+  [Item("MultiPermutationManipulator", "Randomly selects and applies one of its manipulators every time it is called.")]
+  [StorableClass]
+  public class MultiPermutationManipulator : StochasticMultiOperator<IPermutationManipulator>, IPermutationManipulator {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    protected override bool CreateChildOperation {
+      get { return true; }
+    }
+    public override bool AutomaticTypeDiscovery {
+      get { return true; }
+    }
+
+    public ILookupParameter<Permutation> PermutationParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["Permutation"]; }
+    }
+
+    [StorableConstructor]
+    private MultiPermutationManipulator(bool deserializing) : base(deserializing) { }
+    public MultiPermutationManipulator()
+      : base() {
+      Parameters.Add(new LookupParameter<Permutation>("Permutation", "The permutation that is being manipulating."));
+
+      Initialize();
+      ParameterizeManipulators();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      Operators.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IPermutationManipulator>>(Operators_ItemsAdded);
+      Operators.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<IPermutationManipulator>>(Operators_ItemsReplaced);
+    }
+
+    private void Operators_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IPermutationManipulator>> e) {
+      ParameterizeManipulators();
+    }
+
+    private void Operators_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IPermutationManipulator>> e) {
+      ParameterizeManipulators();
+    }
+
+    private void ParameterizeManipulators() {
+      foreach (IPermutationManipulator manipulator in Operators.OfType<IPermutationManipulator>()) {
+        manipulator.PermutationParameter.ActualName = PermutationParameter.Name;
+      }
+      foreach (IStochasticOperator crossover in Operators.OfType<IStochasticOperator>()) {
+        crossover.RandomParameter.ActualName = RandomParameter.Name;
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Crossovers/MultiRealVectorCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Crossovers/MultiRealVectorCrossover.cs	(revision 3425)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Crossovers/MultiRealVectorCrossover.cs	(revision 3425)
@@ -0,0 +1,94 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.RealVectorEncoding {
+  [Item("MultiRealVectorCrossover", "Randomly selects and applies one of its crossovers every time it is called.")]
+  [StorableClass]
+  public class MultiRealVectorCrossover : StochasticMultiOperator<IRealVectorCrossover>, IRealVectorCrossover {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    protected override bool CreateChildOperation {
+      get { return true; }
+    }
+    public override bool AutomaticTypeDiscovery {
+      get { return true; }
+    }
+
+    public ILookupParameter<ItemArray<RealVector>> ParentsParameter {
+      get { return (ILookupParameter<ItemArray<RealVector>>)Parameters["Parents"]; }
+    }
+    public ILookupParameter<RealVector> ChildParameter {
+      get { return (ILookupParameter<RealVector>)Parameters["Child"]; }
+    }
+    public IValueLookupParameter<DoubleMatrix> BoundsParameter {
+      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
+    }
+
+    [StorableConstructor]
+    private MultiRealVectorCrossover(bool deserializing) : base(deserializing) { }
+    public MultiRealVectorCrossover()
+      : base() {
+      Parameters.Add(new SubScopesLookupParameter<RealVector>("Parents", "The parent real vector which should be crossed."));
+      ParentsParameter.ActualName = "RealVector";
+      Parameters.Add(new LookupParameter<RealVector>("Child", "The child real vector resulting from the crossover."));
+      ChildParameter.ActualName = "RealVector";
+      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "The lower and upper bounds for each dimension of the vector."));
+
+      Initialize();
+      ParameterizeCrossovers();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      Operators.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IRealVectorCrossover>>(Operators_ItemsAdded);
+      Operators.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<IRealVectorCrossover>>(Operators_ItemsReplaced);
+    }
+
+    private void Operators_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IRealVectorCrossover>> e) {
+      ParameterizeCrossovers();
+    }
+
+    private void Operators_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IRealVectorCrossover>> e) {
+      ParameterizeCrossovers();
+    }
+
+    private void ParameterizeCrossovers() {
+      foreach (IRealVectorCrossover crossover in Operators.OfType<IRealVectorCrossover>()) {
+        crossover.ChildParameter.ActualName = ChildParameter.Name;
+        crossover.ParentsParameter.ActualName = ParentsParameter.Name;
+        crossover.BoundsParameter.ActualName = BoundsParameter.Name;
+      }
+      foreach (IStochasticOperator crossover in Operators.OfType<IStochasticOperator>()) {
+        crossover.RandomParameter.ActualName = RandomParameter.Name;
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj	(revision 3424)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj	(revision 3425)
@@ -95,4 +95,5 @@
     <Compile Include="Crossovers\HeuristicCrossover.cs" />
     <Compile Include="Crossovers\LocalCrossover.cs" />
+    <Compile Include="Crossovers\MultiRealVectorCrossover.cs" />
     <Compile Include="Crossovers\RandomConvexCrossover.cs" />
     <Compile Include="Crossovers\SimulatedBinaryCrossover.cs" />
@@ -111,4 +112,5 @@
     <Compile Include="Interfaces\IRealVectorMoveGenerator.cs" />
     <Compile Include="Interfaces\IRealVectorMoveOperator.cs" />
+    <Compile Include="Manipulators\MultiRealVectorManipulator.cs" />
     <Compile Include="Manipulators\NormalAllPositionsManipulator.cs" />
     <Compile Include="Moves\AdditiveMoveTabuChecker.cs" />
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Manipulators/MultiRealVectorManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Manipulators/MultiRealVectorManipulator.cs	(revision 3425)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Manipulators/MultiRealVectorManipulator.cs	(revision 3425)
@@ -0,0 +1,87 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.RealVectorEncoding {
+  [Item("MultiRealVectorManipulator", "Randomly selects and applies one of its manipulators every time it is called.")]
+  [StorableClass]
+  public class MultiRealVectorManipulator : StochasticMultiOperator<IRealVectorManipulator>, IRealVectorManipulator {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    protected override bool CreateChildOperation {
+      get { return true; }
+    }
+    public override bool AutomaticTypeDiscovery {
+      get { return true; }
+    }
+
+    public ILookupParameter<RealVector> RealVectorParameter {
+      get { return (ILookupParameter<RealVector>)Parameters["RealVector"]; }
+    }
+    public IValueLookupParameter<DoubleMatrix> BoundsParameter {
+      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
+    }
+
+    [StorableConstructor]
+    private MultiRealVectorManipulator(bool deserializing) : base(deserializing) { }
+    public MultiRealVectorManipulator()
+      : base() {
+      Parameters.Add(new LookupParameter<RealVector>("RealVector", "The real vector that is being manipulating."));
+      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "The lower and upper bounds for each dimension of the vector."));
+
+      Initialize();
+      ParameterizeManipulators();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      Operators.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IRealVectorManipulator>>(Operators_ItemsAdded);
+      Operators.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<IRealVectorManipulator>>(Operators_ItemsReplaced);
+    }
+
+    private void Operators_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IRealVectorManipulator>> e) {
+      ParameterizeManipulators();
+    }
+
+    private void Operators_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IRealVectorManipulator>> e) {
+      ParameterizeManipulators();
+    }
+
+    private void ParameterizeManipulators() {
+      foreach (IRealVectorManipulator manipulator in Operators.OfType<IRealVectorManipulator>()) {
+        manipulator.RealVectorParameter.ActualName = RealVectorParameter.Name;
+        manipulator.BoundsParameter.ActualName = BoundsParameter.Name;
+      }
+      foreach (IStochasticOperator crossover in Operators.OfType<IStochasticOperator>()) {
+        crossover.RandomParameter.ActualName = RandomParameter.Name;
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 3424)
+++ trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 3425)
@@ -91,4 +91,5 @@
     <Compile Include="Assigner.cs" />
     <Compile Include="AlgorithmOperator.cs" />
+    <Compile Include="StochasticMultiOperator.cs" />
     <Compile Include="MultiOperator.cs" />
     <Compile Include="Operator.cs" />
Index: trunk/sources/HeuristicLab.Operators/3.3/StochasticMultiBranch.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/StochasticMultiBranch.cs	(revision 3424)
+++ trunk/sources/HeuristicLab.Operators/3.3/StochasticMultiBranch.cs	(revision 3425)
@@ -20,13 +20,5 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Collections.ObjectModel;
-using System.Linq;
-using HeuristicLab.Collections;
-using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -37,115 +29,7 @@
   [Item("StochasticMultiBranch", "Branch of operators that have different probabilities to get executed.")]
   [StorableClass]
-  public class StochasticMultiBranch : MultiOperator<IOperator> {
-    public ValueLookupParameter<DoubleArray> ProbabilitiesParameter {
-      get { return (ValueLookupParameter<DoubleArray>)Parameters["Probabilities"]; }
-    }
-    public ILookupParameter<IRandom> RandomParameter {
-      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
-    }
-
-    public DoubleArray Probabilities {
-      get { return ProbabilitiesParameter.Value; }
-      set { ProbabilitiesParameter.Value = value; }
-    }
-
-    [StorableConstructor]
-    public StochasticMultiBranch(bool deserializing) : base() { }
-    /// <summary>
-    /// Initializes a new instance of <see cref="StochasticMultiBranch"/> with two parameters
-    /// (<c>Probabilities</c> and <c>Random</c>).
-    /// </summary>
-    public StochasticMultiBranch()
-      : base() {
-      Parameters.Add(new ValueLookupParameter<DoubleArray>("Probabilities", "The array of relative probabilities for each operator.", new DoubleArray()));
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Initialize();
-    }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void Initialize() {
-      Operators.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IOperator>>(Operators_ItemsAdded);
-      Operators.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<IOperator>>(Operators_ItemsRemoved);
-      Operators.ItemsMoved += new CollectionItemsChangedEventHandler<IndexedItem<IOperator>>(Operators_ItemsMoved);
-    }
-
-    void Operators_ItemsMoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOperator>> e) {
-      if (Probabilities != null) {
-        DoubleArray oldProb = (DoubleArray)Probabilities.Clone();
-        foreach (IndexedItem<IOperator> old in e.OldItems) {
-          foreach (IndexedItem<IOperator> item in e.Items) {
-            if (old.Value == item.Value && item.Index < Probabilities.Length && old.Index < oldProb.Length)
-              Probabilities[item.Index] = oldProb[old.Index];
-          }
-        }
-      }
-    }
-
-    void Operators_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOperator>> e) {
-      if (Probabilities != null && Probabilities.Length > Operators.Count) {
-        List<double> probs = new List<double>(Probabilities.Cast<DoubleValue>().Select(x => x.Value));
-        var sorted = e.Items.OrderByDescending(x => x.Index);
-        foreach (IndexedItem<IOperator> item in sorted)
-          if (probs.Count > item.Index) probs.RemoveAt(item.Index);
-        Probabilities = new DoubleArray(probs.ToArray());
-      }
-    }
-
-    private void Operators_ItemsAdded(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IndexedItem<IOperator>> e) {
-      if (Probabilities != null && Probabilities.Length < Operators.Count) {
-        DoubleArray probs = new DoubleArray(Operators.Count);
-        double avg = 0;
-        if (Probabilities.Length > 0) {
-          for (int i = 0; i < Probabilities.Length; i++)
-            avg += Probabilities[i];
-          avg /= (double)Probabilities.Length;
-        } else avg = 1;
-
-        var added = e.Items.OrderBy(x => x.Index).ToList();
-        int insertCount = 0;
-        for (int i = 0; i < Operators.Count; i++) {
-          if (insertCount < added.Count && i == added[insertCount].Index) {
-            probs[i] = avg;
-            insertCount++;
-          } else if (i - insertCount < Probabilities.Length) {
-            probs[i] = Probabilities[i - insertCount];
-          } else probs[i] = avg;
-        }
-        Probabilities = probs;
-      }
-    }
-
-    /// <summary>
-    /// Applies an operator of the branches to the current scope with a 
-    /// specific probability.
-    /// </summary>
-    /// <exception cref="InvalidOperationException">Thrown when the list of probabilites does not
-    /// match the number of operators.</exception>
-    /// <returns>A new operation with the operator that was selected followed by the current operator's successor.</returns>
-    public override IOperation Apply() {
-      IRandom random = RandomParameter.ActualValue;
-      DoubleArray probabilities = ProbabilitiesParameter.ActualValue;
-      if(probabilities.Length != Operators.Count) {
-        throw new InvalidOperationException("StochasticMultiBranch: The list of probabilities has to match the number of operators");
-      }
-      double sum = 0;
-      for (int i = 0; i < Operators.Count; i++) {
-        sum += probabilities[i];
-      }
-      double r = random.NextDouble() * sum;
-      sum = 0;
-      IOperator successor = null;
-      for(int i = 0; i < Operators.Count; i++) {
-        sum += probabilities[i];
-        if(sum > r) {
-          successor = Operators[i];
-          break;
-        }
-      }
-      OperationCollection next = new OperationCollection(base.Apply());
-      if (successor != null) {
-        next.Insert(0, ExecutionContext.CreateOperation(successor));
-      }
-      return next;
+  public class StochasticMultiBranch : StochasticMultiOperator<IOperator> {
+    protected override bool CreateChildOperation {
+      get { return false; }
     }
   }
Index: trunk/sources/HeuristicLab.Operators/3.3/StochasticMultiOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/StochasticMultiOperator.cs	(revision 3425)
+++ trunk/sources/HeuristicLab.Operators/3.3/StochasticMultiOperator.cs	(revision 3425)
@@ -0,0 +1,171 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// Base class for stochastic multi operators.
+  /// </summary>
+  [Item("StochasticMultiOperator", "Base class for stochastic multi operators.")]
+  [StorableClass]
+  public abstract class StochasticMultiOperator<T> : MultiOperator<T> where T : class, IOperator {
+    /// <summary>
+    /// Returns false by default. If this is overriden to return true, there will be an automatic type discovery
+    /// of all instantiable types of T (except the own type) and instances will be added to the Operators list.
+    /// </summary>
+    public virtual bool AutomaticTypeDiscovery { get { return false; } }
+    /// <summary>
+    /// Should return true if the StochasticMultiOperator should create a new child operation with the selected successor
+    /// or if it should create a new operation. If you need to shield the parameters of the successor you should return true here.
+    /// </summary>
+    protected abstract bool CreateChildOperation { get; }
+
+    public ValueLookupParameter<DoubleArray> ProbabilitiesParameter {
+      get { return (ValueLookupParameter<DoubleArray>)Parameters["Probabilities"]; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    public DoubleArray Probabilities {
+      get { return ProbabilitiesParameter.Value; }
+      set { ProbabilitiesParameter.Value = value; }
+    }
+
+    [StorableConstructor]
+    protected StochasticMultiOperator(bool deserializing) : base(deserializing) { }
+    /// <summary>
+    /// Initializes a new instance of <see cref="StochasticMultiBranch"/> with two parameters
+    /// (<c>Probabilities</c> and <c>Random</c>).
+    /// </summary>
+    public StochasticMultiOperator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<DoubleArray>("Probabilities", "The array of relative probabilities for each operator.", new DoubleArray()));
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
+      Initialize();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      Operators.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<T>>(Operators_ItemsAdded);
+      Operators.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<T>>(Operators_ItemsRemoved);
+      Operators.ItemsMoved += new CollectionItemsChangedEventHandler<IndexedItem<T>>(Operators_ItemsMoved);
+      if (AutomaticTypeDiscovery) {
+        IEnumerable<Type> types = ApplicationManager.Manager.GetTypes(typeof(T), true);
+        foreach (Type type in types.OrderBy(x => x.FullName)) {
+          if (type != this.GetType())
+            Operators.Add((T)Activator.CreateInstance(type));
+        }
+      }
+    }
+
+    void Operators_ItemsMoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<T>> e) {
+      if (Probabilities != null) {
+        DoubleArray oldProb = (DoubleArray)Probabilities.Clone();
+        foreach (IndexedItem<T> old in e.OldItems) {
+          foreach (IndexedItem<T> item in e.Items) {
+            if (old.Value == item.Value && item.Index < Probabilities.Length && old.Index < oldProb.Length)
+              Probabilities[item.Index] = oldProb[old.Index];
+          }
+        }
+      }
+    }
+
+    void Operators_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<T>> e) {
+      if (Probabilities != null && Probabilities.Length > Operators.Count) {
+        List<double> probs = new List<double>(Probabilities.Cast<double>());
+        var sorted = e.Items.OrderByDescending(x => x.Index);
+        foreach (IndexedItem<T> item in sorted)
+          if (probs.Count > item.Index) probs.RemoveAt(item.Index);
+        Probabilities = new DoubleArray(probs.ToArray());
+      }
+    }
+
+    private void Operators_ItemsAdded(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IndexedItem<T>> e) {
+      if (Probabilities != null && Probabilities.Length < Operators.Count) {
+        DoubleArray probs = new DoubleArray(Operators.Count);
+        double avg = 0;
+        if (Probabilities.Length > 0) {
+          for (int i = 0; i < Probabilities.Length; i++)
+            avg += Probabilities[i];
+          avg /= (double)Probabilities.Length;
+        } else avg = 1;
+
+        var added = e.Items.OrderBy(x => x.Index).ToList();
+        int insertCount = 0;
+        for (int i = 0; i < Operators.Count; i++) {
+          if (insertCount < added.Count && i == added[insertCount].Index) {
+            probs[i] = avg;
+            insertCount++;
+          } else if (i - insertCount < Probabilities.Length) {
+            probs[i] = Probabilities[i - insertCount];
+          } else probs[i] = avg;
+        }
+        Probabilities = probs;
+      }
+    }
+
+    /// <summary>
+    /// Applies an operator of the branches to the current scope with a 
+    /// specific probability.
+    /// </summary>
+    /// <exception cref="InvalidOperationException">Thrown when the list of probabilites does not
+    /// match the number of operators.</exception>
+    /// <returns>A new operation with the operator that was selected followed by the current operator's successor.</returns>
+    public override IOperation Apply() {
+      IRandom random = RandomParameter.ActualValue;
+      DoubleArray probabilities = ProbabilitiesParameter.ActualValue;
+      if(probabilities.Length != Operators.Count) {
+        throw new InvalidOperationException("MultiCrossover: The list of probabilities has to match the number of operators");
+      }
+      double sum = 0;
+      for (int i = 0; i < Operators.Count; i++) {
+        sum += probabilities[i];
+      }
+      double r = random.NextDouble() * sum;
+      sum = 0;
+      IOperator successor = null;
+      for(int i = 0; i < Operators.Count; i++) {
+        sum += probabilities[i];
+        if(sum > r) {
+          successor = Operators[i];
+          break;
+        }
+      }
+      OperationCollection next = new OperationCollection(base.Apply());
+      if (successor != null) {
+        if (CreateChildOperation)
+          next.Insert(0, ExecutionContext.CreateChildOperation(successor));
+        else next.Insert(0, ExecutionContext.CreateOperation(successor));
+      }
+      return next;
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj	(revision 3424)
+++ trunk/sources/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj	(revision 3425)
@@ -93,5 +93,4 @@
     <Compile Include="QualityComparator.cs" />
     <Compile Include="SolutionsCreator.cs" />
-    <Compile Include="MultiCrossover.cs" />
     <Compile Include="TabuMaker.cs" />
     <Compile Include="UnidirectionalRingMigrator.cs" />
Index: trunk/sources/HeuristicLab.Optimization.Operators/3.3/MultiCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Operators/3.3/MultiCrossover.cs	(revision 3424)
+++ 	(revision )
@@ -1,159 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Collections.ObjectModel;
-using System.Linq;
-using HeuristicLab.Collections;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Optimization;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.Operators {
-  /// <summary>
-  /// Base class for multi crossover operators.
-  /// </summary>
-  [Item("MultiCrossover", "Base class for multi crossover operators.")]
-  [StorableClass]
-  public class MultiCrossover<T> : MultiOperator<T>, IStochasticOperator where T : class, ICrossover {
-    public ValueLookupParameter<DoubleArray> ProbabilitiesParameter {
-      get { return (ValueLookupParameter<DoubleArray>)Parameters["Probabilities"]; }
-    }
-    public ILookupParameter<IRandom> RandomParameter {
-      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
-    }
-
-    public DoubleArray Probabilities {
-      get { return ProbabilitiesParameter.Value; }
-      set { ProbabilitiesParameter.Value = value; }
-    }
-
-    [StorableConstructor]
-    protected MultiCrossover(bool deserializing) : base(deserializing) { }
-    /// <summary>
-    /// Initializes a new instance of <see cref="StochasticMultiBranch"/> with two parameters
-    /// (<c>Probabilities</c> and <c>Random</c>).
-    /// </summary>
-    public MultiCrossover()
-      : base() {
-      Parameters.Add(new ValueLookupParameter<DoubleArray>("Probabilities", "The array of relative probabilities for each operator.", new DoubleArray()));
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Initialize();
-    }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void Initialize() {
-      Operators.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<T>>(Operators_ItemsAdded);
-      Operators.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<T>>(Operators_ItemsRemoved);
-      Operators.ItemsMoved += new CollectionItemsChangedEventHandler<IndexedItem<T>>(Operators_ItemsMoved);
-      IEnumerable<Type> types = ApplicationManager.Manager.GetTypes(typeof(T), true);
-      foreach (Type type in types) {
-        if (type != this.GetType())
-          Operators.Add((T)Activator.CreateInstance(type));
-      }
-    }
-
-    void Operators_ItemsMoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<T>> e) {
-      if (Probabilities != null) {
-        DoubleArray oldProb = (DoubleArray)Probabilities.Clone();
-        foreach (IndexedItem<T> old in e.OldItems) {
-          foreach (IndexedItem<T> item in e.Items) {
-            if (old.Value == item.Value && item.Index < Probabilities.Length && old.Index < oldProb.Length)
-              Probabilities[item.Index] = oldProb[old.Index];
-          }
-        }
-      }
-    }
-
-    void Operators_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<T>> e) {
-      if (Probabilities != null && Probabilities.Length > Operators.Count) {
-        List<double> probs = new List<double>(Probabilities.Cast<double>());
-        var sorted = e.Items.OrderByDescending(x => x.Index);
-        foreach (IndexedItem<T> item in sorted)
-          if (probs.Count > item.Index) probs.RemoveAt(item.Index);
-        Probabilities = new DoubleArray(probs.ToArray());
-      }
-    }
-
-    private void Operators_ItemsAdded(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IndexedItem<T>> e) {
-      if (Probabilities != null && Probabilities.Length < Operators.Count) {
-        DoubleArray probs = new DoubleArray(Operators.Count);
-        double avg = 0;
-        if (Probabilities.Length > 0) {
-          for (int i = 0; i < Probabilities.Length; i++)
-            avg += Probabilities[i];
-          avg /= (double)Probabilities.Length;
-        } else avg = 1;
-
-        var added = e.Items.OrderBy(x => x.Index).ToList();
-        int insertCount = 0;
-        for (int i = 0; i < Operators.Count; i++) {
-          if (insertCount < added.Count && i == added[insertCount].Index) {
-            probs[i] = avg;
-            insertCount++;
-          } else if (i - insertCount < Probabilities.Length) {
-            probs[i] = Probabilities[i - insertCount];
-          } else probs[i] = avg;
-        }
-        Probabilities = probs;
-      }
-    }
-
-    /// <summary>
-    /// Applies an operator of the branches to the current scope with a 
-    /// specific probability.
-    /// </summary>
-    /// <exception cref="InvalidOperationException">Thrown when the list of probabilites does not
-    /// match the number of operators.</exception>
-    /// <returns>A new operation with the operator that was selected followed by the current operator's successor.</returns>
-    public override IOperation Apply() {
-      IRandom random = RandomParameter.ActualValue;
-      DoubleArray probabilities = ProbabilitiesParameter.ActualValue;
-      if(probabilities.Length != Operators.Count) {
-        throw new InvalidOperationException("MultiCrossover: The list of probabilities has to match the number of operators");
-      }
-      double sum = 0;
-      for (int i = 0; i < Operators.Count; i++) {
-        sum += probabilities[i];
-      }
-      double r = random.NextDouble() * sum;
-      sum = 0;
-      IOperator successor = null;
-      for(int i = 0; i < Operators.Count; i++) {
-        sum += probabilities[i];
-        if(sum > r) {
-          successor = Operators[i];
-          break;
-        }
-      }
-      OperationCollection next = new OperationCollection(base.Apply());
-      if (successor != null) {
-        next.Insert(0, ExecutionContext.CreateChildOperation(successor));
-      }
-      return next;
-    }
-  }
-}
